#include "stacktool.h"
#include "bdd_bitbit_and.h"

static int and_8_res_0_tmp_0 (void) {
  return bdd_op_inputs[24];
}

static int and_8_res_0_tmp_1 (void) {
  return bdd_op_inputs[25];
}

static int and_8_res_0_tmp_2 (void) {
  return bdd_op_inputs[26];
}

static int and_8_res_0_tmp_3 (void) {
  return bdd_op_inputs[27];
}

static int and_8_res_0_tmp_4 (void) {
  return bdd_op_inputs[28];
}

static int and_8_res_0_tmp_5 (void) {
  return bdd_op_inputs[29];
}

static int and_8_res_0_tmp_6 (void) {
  return bdd_op_inputs[30];
}

static int and_8_res_0_tmp_7 (void) {
  return bdd_op_inputs[31];
}

struct mem_loc_t bdd_bitbit_and_res (struct mem_loc_t in1, struct mem_loc_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2.val, bdd_op_inputs, 2 * 8);
  explode (in2.known, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = (bdd_op_inputs[0] && bdd_op_inputs[16]);
  // bitbit_01_0_8.bdd
  outputs[1] = (bdd_op_inputs[1] && bdd_op_inputs[17]);
  // bitbit_02_0_8.bdd
  outputs[2] = (bdd_op_inputs[2] && bdd_op_inputs[18]);
  // bitbit_03_0_8.bdd
  outputs[3] = (bdd_op_inputs[3] && bdd_op_inputs[19]);
  // bitbit_04_0_8.bdd
  outputs[4] = (bdd_op_inputs[4] && bdd_op_inputs[20]);
  // bitbit_05_0_8.bdd
  outputs[5] = (bdd_op_inputs[5] && bdd_op_inputs[21]);
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[6] && bdd_op_inputs[22]);
  // bitbit_07_0_8.bdd
  outputs[7] = (bdd_op_inputs[7] && bdd_op_inputs[23]);
  // bitbit_08_0_8.bdd
  outputs[8] = (bdd_op_inputs[0]?and_8_res_0_tmp_0 ():(bdd_op_inputs[8] || (bdd_op_inputs[16]?0:and_8_res_0_tmp_0 ())));
  // bitbit_09_0_8.bdd
  outputs[9] = (bdd_op_inputs[1]?and_8_res_0_tmp_1 ():(bdd_op_inputs[9] || (bdd_op_inputs[17]?0:and_8_res_0_tmp_1 ())));
  // bitbit_10_0_8.bdd
  outputs[10] = (bdd_op_inputs[2]?and_8_res_0_tmp_2 ():(bdd_op_inputs[10] || (bdd_op_inputs[18]?0:and_8_res_0_tmp_2 ())));
  // bitbit_11_0_8.bdd
  outputs[11] = (bdd_op_inputs[3]?and_8_res_0_tmp_3 ():(bdd_op_inputs[11] || (bdd_op_inputs[19]?0:and_8_res_0_tmp_3 ())));
  // bitbit_12_0_8.bdd
  outputs[12] = (bdd_op_inputs[4]?and_8_res_0_tmp_4 ():(bdd_op_inputs[12] || (bdd_op_inputs[20]?0:and_8_res_0_tmp_4 ())));
  // bitbit_13_0_8.bdd
  outputs[13] = (bdd_op_inputs[5]?and_8_res_0_tmp_5 ():(bdd_op_inputs[13] || (bdd_op_inputs[21]?0:and_8_res_0_tmp_5 ())));
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[6]?and_8_res_0_tmp_6 ():(bdd_op_inputs[14] || (bdd_op_inputs[22]?0:and_8_res_0_tmp_6 ())));
  // bitbit_15_0_8.bdd
  outputs[15] = (bdd_op_inputs[7]?and_8_res_0_tmp_7 ():(bdd_op_inputs[15] || (bdd_op_inputs[23]?0:and_8_res_0_tmp_7 ())));
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int and_8_cc_0_tmp_0 (void) {
  return (bdd_op_inputs[0] && bdd_op_inputs[16]);
}

static int and_8_cc_0_tmp_1 (void) {
  return bdd_op_inputs[31];
}

static int and_8_cc_0_tmp_2 (void) {
  return (bdd_op_inputs[23]?0:and_8_cc_0_tmp_1 ());
}

static int and_8_cc_0_tmp_3 (void) {
  return (bdd_op_inputs[15] || and_8_cc_0_tmp_2 ());
}

static int and_8_cc_0_tmp_4 (void) {
  return (bdd_op_inputs[7]?and_8_cc_0_tmp_2 ():and_8_cc_0_tmp_3 ());
}

static int and_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[22]?0:(bdd_op_inputs[30] && and_8_cc_0_tmp_4 ()));
}

static int and_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[6]?and_8_cc_0_tmp_5 ():(bdd_op_inputs[14]?and_8_cc_0_tmp_4 ():and_8_cc_0_tmp_5 ()));
}

static int and_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[21]?0:(bdd_op_inputs[29] && and_8_cc_0_tmp_6 ()));
}

static int and_8_cc_0_tmp_8 (void) {
  return (bdd_op_inputs[5]?and_8_cc_0_tmp_7 ():(bdd_op_inputs[13]?and_8_cc_0_tmp_6 ():and_8_cc_0_tmp_7 ()));
}

static int and_8_cc_0_tmp_9 (void) {
  return (bdd_op_inputs[20]?0:(bdd_op_inputs[28] && and_8_cc_0_tmp_8 ()));
}

static int and_8_cc_0_tmp_10 (void) {
  return (bdd_op_inputs[4]?and_8_cc_0_tmp_9 ():(bdd_op_inputs[12]?and_8_cc_0_tmp_8 ():and_8_cc_0_tmp_9 ()));
}

static int and_8_cc_0_tmp_11 (void) {
  return (bdd_op_inputs[19]?0:(bdd_op_inputs[27] && and_8_cc_0_tmp_10 ()));
}

static int and_8_cc_0_tmp_12 (void) {
  return (bdd_op_inputs[3]?and_8_cc_0_tmp_11 ():(bdd_op_inputs[11]?and_8_cc_0_tmp_10 ():and_8_cc_0_tmp_11 ()));
}

static int and_8_cc_0_tmp_13 (void) {
  return (bdd_op_inputs[18]?0:(bdd_op_inputs[26] && and_8_cc_0_tmp_12 ()));
}

static int and_8_cc_0_tmp_14 (void) {
  return (bdd_op_inputs[2]?and_8_cc_0_tmp_13 ():(bdd_op_inputs[10]?and_8_cc_0_tmp_12 ():and_8_cc_0_tmp_13 ()));
}

static int and_8_cc_0_tmp_15 (void) {
  return (bdd_op_inputs[17]?0:(bdd_op_inputs[25] && and_8_cc_0_tmp_14 ()));
}

static int and_8_cc_0_tmp_16 (void) {
  return (bdd_op_inputs[1]?and_8_cc_0_tmp_15 ():(bdd_op_inputs[9]?and_8_cc_0_tmp_14 ():and_8_cc_0_tmp_15 ()));
}

static int and_8_cc_0_tmp_17 (void) {
  return (bdd_op_inputs[16]?0:(bdd_op_inputs[24] && and_8_cc_0_tmp_16 ()));
}

static int and_8_cc_0_tmp_18 (void) {
  return bdd_op_inputs[24];
}

static int and_8_cc_0_tmp_19 (void) {
  return (bdd_op_inputs[0]?and_8_cc_0_tmp_18 ():(bdd_op_inputs[8] || (bdd_op_inputs[16]?0:and_8_cc_0_tmp_18 ())));
}

static int and_8_cc_0_tmp_20 (void) {
  return (bdd_op_inputs[7]?and_8_cc_0_tmp_1 ():and_8_cc_0_tmp_3 ());
}

static int and_8_cc_0_tmp_21 (void) {
  return (bdd_op_inputs[7] && bdd_op_inputs[23]);
}

static int and_8_cc_0_tmp_22 (void) {
  return (bdd_op_inputs[30]?and_8_cc_0_tmp_20 ():and_8_cc_0_tmp_21 ());
}

static int and_8_cc_0_tmp_23 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22] || and_8_cc_0_tmp_22 ()):(bdd_op_inputs[14]?and_8_cc_0_tmp_20 ():(bdd_op_inputs[22]?and_8_cc_0_tmp_21 ():and_8_cc_0_tmp_22 ())));
}

static int and_8_cc_0_tmp_24 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22] || and_8_cc_0_tmp_21 ()):and_8_cc_0_tmp_21 ());
}

static int and_8_cc_0_tmp_25 (void) {
  return (bdd_op_inputs[29]?and_8_cc_0_tmp_23 ():and_8_cc_0_tmp_24 ());
}

static int and_8_cc_0_tmp_26 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21] || and_8_cc_0_tmp_25 ()):(bdd_op_inputs[13]?and_8_cc_0_tmp_23 ():(bdd_op_inputs[21]?and_8_cc_0_tmp_24 ():and_8_cc_0_tmp_25 ())));
}

static int and_8_cc_0_tmp_27 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21] || and_8_cc_0_tmp_24 ()):and_8_cc_0_tmp_24 ());
}

static int and_8_cc_0_tmp_28 (void) {
  return (bdd_op_inputs[28]?and_8_cc_0_tmp_26 ():and_8_cc_0_tmp_27 ());
}

static int and_8_cc_0_tmp_29 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20] || and_8_cc_0_tmp_28 ()):(bdd_op_inputs[12]?and_8_cc_0_tmp_26 ():(bdd_op_inputs[20]?and_8_cc_0_tmp_27 ():and_8_cc_0_tmp_28 ())));
}

static int and_8_cc_0_tmp_30 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20] || and_8_cc_0_tmp_27 ()):and_8_cc_0_tmp_27 ());
}

static int and_8_cc_0_tmp_31 (void) {
  return (bdd_op_inputs[27]?and_8_cc_0_tmp_29 ():and_8_cc_0_tmp_30 ());
}

static int and_8_cc_0_tmp_32 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19] || and_8_cc_0_tmp_31 ()):(bdd_op_inputs[11]?and_8_cc_0_tmp_29 ():(bdd_op_inputs[19]?and_8_cc_0_tmp_30 ():and_8_cc_0_tmp_31 ())));
}

static int and_8_cc_0_tmp_33 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19] || and_8_cc_0_tmp_30 ()):and_8_cc_0_tmp_30 ());
}

static int and_8_cc_0_tmp_34 (void) {
  return (bdd_op_inputs[26]?and_8_cc_0_tmp_32 ():and_8_cc_0_tmp_33 ());
}

static int and_8_cc_0_tmp_35 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18] || and_8_cc_0_tmp_34 ()):(bdd_op_inputs[10]?and_8_cc_0_tmp_32 ():(bdd_op_inputs[18]?and_8_cc_0_tmp_33 ():and_8_cc_0_tmp_34 ())));
}

static int and_8_cc_0_tmp_36 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18] || and_8_cc_0_tmp_33 ()):and_8_cc_0_tmp_33 ());
}

static int and_8_cc_0_tmp_37 (void) {
  return (bdd_op_inputs[25]?and_8_cc_0_tmp_35 ():and_8_cc_0_tmp_36 ());
}

static int and_8_cc_0_tmp_38 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17] || and_8_cc_0_tmp_37 ()):(bdd_op_inputs[9]?and_8_cc_0_tmp_35 ():(bdd_op_inputs[17]?and_8_cc_0_tmp_36 ():and_8_cc_0_tmp_37 ())));
}

static int and_8_cc_0_tmp_39 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17] || and_8_cc_0_tmp_36 ()):and_8_cc_0_tmp_36 ());
}

static int and_8_cc_0_tmp_40 (void) {
  return (bdd_op_inputs[24]?and_8_cc_0_tmp_38 ():and_8_cc_0_tmp_39 ());
}

struct mem_loc_t bdd_bitbit_and_cc (struct mem_loc_t in1, struct mem_loc_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2.val, bdd_op_inputs, 2 * 8);
  explode (in2.known, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = and_8_cc_0_tmp_0 ();
  // bitbit_04_0_8.bdd
  outputs[4] = 0;
  // bitbit_05_0_8.bdd
  outputs[5] = and_8_cc_0_tmp_0 ();
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[0]?and_8_cc_0_tmp_17 ():(bdd_op_inputs[8]?and_8_cc_0_tmp_16 ():and_8_cc_0_tmp_17 ()));
  // bitbit_07_0_8.bdd
  outputs[7] = 0;
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = and_8_cc_0_tmp_19 ();
  // bitbit_12_0_8.bdd
  outputs[12] = 1;
  // bitbit_13_0_8.bdd
  outputs[13] = and_8_cc_0_tmp_19 ();
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[0]?(bdd_op_inputs[16] || and_8_cc_0_tmp_40 ()):(bdd_op_inputs[8]?and_8_cc_0_tmp_38 ():(bdd_op_inputs[16]?and_8_cc_0_tmp_39 ():and_8_cc_0_tmp_40 ())));
  // bitbit_15_0_8.bdd
  outputs[15] = 1;
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

struct mem_loc_t bdd_bitbit_and_diag_res (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_0_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int and_diag_8_cc_0_tmp_0 (void) {
  return bdd_op_inputs[0];
}

static int and_diag_8_cc_0_tmp_1 (void) {
  return bdd_op_inputs[15];
}

static int and_diag_8_cc_0_tmp_2 (void) {
  return bdd_op_inputs[8];
}

static int and_diag_8_cc_0_tmp_3 (void) {
  return bdd_op_inputs[7];
}

static int and_diag_8_cc_0_tmp_4 (void) {
  return (bdd_op_inputs[6] || and_diag_8_cc_0_tmp_3 ());
}

static int and_diag_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[5] || and_diag_8_cc_0_tmp_4 ());
}

static int and_diag_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[4] || and_diag_8_cc_0_tmp_5 ());
}

static int and_diag_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[3] || and_diag_8_cc_0_tmp_6 ());
}

static int and_diag_8_cc_0_tmp_8 (void) {
  return (bdd_op_inputs[2] || and_diag_8_cc_0_tmp_7 ());
}

struct mem_loc_t bdd_bitbit_and_diag_cc (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = and_diag_8_cc_0_tmp_0 ();
  // bitbit_04_0_8.bdd
  outputs[4] = 0;
  // bitbit_05_0_8.bdd
  outputs[5] = and_diag_8_cc_0_tmp_0 ();
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[0]?0:(bdd_op_inputs[8] && (bdd_op_inputs[1]?0:(bdd_op_inputs[9] && (bdd_op_inputs[2]?0:(bdd_op_inputs[10] && (bdd_op_inputs[3]?0:(bdd_op_inputs[11] && (bdd_op_inputs[4]?0:(bdd_op_inputs[12] && (bdd_op_inputs[5]?0:(bdd_op_inputs[13] && (bdd_op_inputs[6]?0:(bdd_op_inputs[14] && (bdd_op_inputs[7]?0:and_diag_8_cc_0_tmp_1 ())))))))))))))));
  // bitbit_07_0_8.bdd
  outputs[7] = 0;
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = and_diag_8_cc_0_tmp_2 ();
  // bitbit_12_0_8.bdd
  outputs[12] = 1;
  // bitbit_13_0_8.bdd
  outputs[13] = and_diag_8_cc_0_tmp_2 ();
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[0] || (bdd_op_inputs[8]?(bdd_op_inputs[1] || (bdd_op_inputs[9]?(bdd_op_inputs[2] || (bdd_op_inputs[10]?(bdd_op_inputs[3] || (bdd_op_inputs[11]?(bdd_op_inputs[4] || (bdd_op_inputs[12]?(bdd_op_inputs[5] || (bdd_op_inputs[13]?(bdd_op_inputs[6] || (bdd_op_inputs[14]?and_diag_8_cc_0_tmp_1 ():and_diag_8_cc_0_tmp_3 ())):and_diag_8_cc_0_tmp_4 ())):and_diag_8_cc_0_tmp_5 ())):and_diag_8_cc_0_tmp_6 ())):and_diag_8_cc_0_tmp_7 ())):and_diag_8_cc_0_tmp_8 ())):(bdd_op_inputs[1] || and_diag_8_cc_0_tmp_8 ())));
  // bitbit_15_0_8.bdd
  outputs[15] = 1;
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_and (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  if (src_reg == dst_reg)  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_and_diag_res (get_mem (m, dst_reg), ccin);
    struct mem_loc_t cc  = bdd_bitbit_and_diag_cc  (get_mem (m, dst_reg), ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x1e);
  } else {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_and_res (get_mem (m, dst_reg), get_mem (m, src_reg), ccin);
    struct mem_loc_t cc  = bdd_bitbit_and_cc  (get_mem (m, dst_reg), get_mem (m, src_reg), ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x1e);
  }
}
#endif

#ifdef STACKTOOL
void classic_bitbit_and (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  struct decoder_info dec;
  dec.opcode = AVR_and;
#if (2==2)
#if 0
  dec.K = imm;
  dec.K_set = 1;  
#else
  dec.src_reg = src_reg;
  dec.src_reg_set = 1;
#endif
#endif
  dec.dst_reg = dst_reg;
  dec.dst_reg_set = 1;
  abstract_interp_insn (m, &dec);
}
#endif

